#include "serial.h"

int fd;

int init_serial(const char *port, int baudrate) {
    int fd = open(port, O_RDWR | O_NOCTTY | O_NDELAY);
    if (fd == -1) {
        perror("open serial port");
        return -1;
    }

    struct termios options;
    tcgetattr(fd, &options);

    // 设置波特率
    cfsetispeed(&options, B9600);
    cfsetospeed(&options, B9600);

    // 配置串口
    options.c_cflag &= ~PARENB; // 无校验
    options.c_cflag &= ~CSTOPB; // 1停止位
    options.c_cflag &= ~CSIZE;  // 清除数据位设置
    options.c_cflag |= CS8;     // 8数据位
    options.c_cflag |= CLOCAL | CREAD; // 忽略调制解调器状态，开启接收器

    options.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG); // 原始模式
    options.c_iflag &= ~(IXON | IXOFF | IXANY);         // 禁用流控
    options.c_oflag &= ~OPOST;                         // 原始输出

    tcsetattr(fd, TCSANOW, &options);
    return fd;
}




void serial_Receive() {
    char buffer[254]="\0";
    while (1) { 
        int bytes_read = read(fd, buffer, sizeof(buffer)-1);
        if (bytes_read > 0) {
             //printf("Received chatdate: %s\n", buffer);
            buffer[bytes_read] = '\0';
            printf("Received chatdate:: %s\n", buffer);
            //int receivedNumber = atoi(buffer);
            //printf("Received intdate: %d\n", receivedNumber);
        }
    }
    close(fd);
    //free(buffer);
}

void serial_Write(unsigned char *buf)
{
    unsigned char buffers[5];
    buffers[0]=0xAA;
    //write(fd, buffers[0], sizeof(buffers));
    for(int i=1;i<4;i++)
    {
        buffers[i]=buf[i-1];
        //write(fd, buffers[i], sizeof(buffers));
    }
    buffers[4]=0xFE;
    write(fd, buffers, sizeof(buffers));
    
    //printf("%d\n",buffers[0]);
    //printf("%d\n",buffers[1]);
    //printf("%d\n",buffers[2]);
    //printf("%d\n",buffers[3]);
    //printf("%d\n",buffers[4]);
}



int serial_Init()
{
    fd = init_serial(SERIAL_PORT, 9600);
    if (fd == -1) return -1;
    printf("Serial communication started...\n");
    
}
